using System;
using System.Collections.Generic;
using System.Collections;
using System.Text;
using System.Web;
using System.IO;



namespace DirBrowse
{
    /// <summary>
    /// Summary description for DirBrowseModule
    /// </summary>
    public class DirBrowseModule :  IHttpModule
    {
        public DirBrowseModule()
        {
            //
            // TODO: Add constructor logic here
            //
        }
        
        public void Init(HttpApplication httpApp)
        {
            httpApp.PreRequestHandlerExecute += (new EventHandler(this.BeginRequest));
         //   httpApp.EndRequest += new EventHandler(this.EndRrequest);
        }

        void BeginRequest(Object src, EventArgs e)
        {
            HttpApplication httpApp = (HttpApplication)src;
            HttpContext Context = httpApp.Context;
            HttpRequest Request = Context.Request;
            HttpResponse Response = Context.Response;

            DirectoryInfo d = new DirectoryInfo(Request.PhysicalPath);
            if (d.Exists)
            {
                Response.Write("<HTML><HEAD><TITLE>Bernhard's view on ");
                Response.Write(d.FullName);
                Response.Write("</TITLE></HEAD><BODY>");
                //Response.Write(Request.PhysicalPath.ToString());
                ShowDirlist(d, Request, Response);
                Response.Write("<BODY></HTML>");
            }
        }

        void ShowDirlist(DirectoryInfo d, HttpRequest Request, HttpResponse Response)
        {
            //get collection of files and directories
            FileSystemInfo[] fsi = d.GetFileSystemInfos();

            // Show it in a table
            Response.Write("<center><table border=1 cols=4>");

            Response.Write("\n");
            Response.Write("<TD style=\"font-family: Arial\">");

            Response.Write("<a href=\"../\">[Parent]</A>");
            Response.Write("</TD>");
//            Response.Write("</TR>");
            int colcount = 1;
            foreach (FileSystemInfo file in fsi)
            {
                Response.Write("\n");
                if (colcount++ == 4)
                    Response.Write ("<TR>");

                Response.Write("<TD style=\"font-family: Arial\">");

                
                // Is it a direcory
                if (file.Attributes == System.IO.FileAttributes.Directory)
                {
                    Response.Write(
                        "<a href=\"" + Request.PathInfo + file.Name + "/\">" 
                         + file.Name 
                         + "</A>");
                }
                else
                {  //Regular Files

          //          if (( file.Extension.ToLower() == ".jpg" ) || (file.Extension.ToLower() == ".exe"))
                    {
                        Response.Write(       
                        "<a href=\"" + Request.PathInfo + file.Name + "\">" 
                        + "<IMG SRC = \"" +  file.Name + ".img?Height=100\">"
                        + "</A>");
                        Response.Write("<BR>" + file.Name);

                    }
                    //else
                    //{
                    //    Response.Write(file.Name);
                    //}
                }


                Response.Write("</TD>");
                if (colcount == 4)
                {
                    Response.Write("</TR>");
                    colcount = 0 ;
                }

            }

            Response.Write("</table></center>");


        }

        #region IHttpModule Members

        public void Dispose()
        {
            
        }
        public bool IsReusable
        {
            get { return false; }
        }

        #endregion
}

}